///////////////////////////////////////////////////
//Beispiel Blüten aus Kapitel Räumliche Strukturen.
//Es werden als Anwendungsbeispiel für eigene Shapes und bezierVertex
//bunte Blüten-Shapes gezeichnet
////////////////////////////////////////////////////////
int anzahlBluetenblaetter = 0;
int N = 80; //Anzahl Blüten
float radiusKlein = 0;
float radiusGross = 0;

void setup()
{
  size(1200, 1200);
  smooth(); 
}

void draw()
{
  background(255);
  for (int i=1; i<=N; i++) { // so entstehen N Blüten
    pushMatrix();
    translate(random(100, width-100), random(100, height-100)); //zufälliger Ort
    anzahlBluetenblaetter = round(random(5, 16));//zufällige Anzahl an Blütenblättern
    radiusKlein = random(width/100, 2*width/100); //zufälliger kleiner Radius
    radiusGross = radiusKlein + random( 4*width/100,  6*width/100);
    zeichneBluete(anzahlBluetenblaetter, radiusKlein, radiusGross);
    popMatrix();
  }
  noLoop();
}

void zeichneBluete( int anzahlBluetenblaetter, float radiusKlein, float radiusGross )
{
  float delta = 2*PI / anzahlBluetenblaetter;   
  beginShape();
    fill(random(256), random(256), random(256));  //Zufallsfarbe
    //Alle nötigen Punkte auf den Kreisen werden berechnet
    vertex( radiusKlein, 0 );    
    for ( int i = 0; i <= anzahlBluetenblaetter-1; i++ ) {
      float cx1 = cos( delta * i ) * radiusGross;
      float cy1 = sin( delta * i ) * radiusGross;
      float x2 = cos( delta * (i + 1) ) * radiusKlein; 
      float y2 = sin( delta * (i + 1) ) * radiusKlein; 
      float cx2 = cos( delta * (i + 1) ) * radiusGross; 
      float cy2 = sin( delta * (i + 1) ) * radiusGross;       
      bezierVertex( cx1, cy1, cx2, cy2, x2, y2 );
    }   
  endShape();
  stroke(0);
  fill(random(256), random(256), random(256));//strokeWeight(1);
  ellipse(0, 0, 2*radiusKlein, 2*radiusKlein);
}

void mousePressed() {
  redraw();
}

void keyPressed() {
  save("test.png");
}